;Rafael Trivino
;CSC410 FINAL
;A Program that makes a blue box that toggles mouse interrupt
;and can be typed into through cursor positioning, with limited
;spaceing. December 8th, 2011
;BASED ON CATS CRADLE, 3:15AM IDEA
TITLE				TESTDRIVE3
.MODEL				SMALL
.STACK				100h

include\masm32\include\masm32rt.inc

FORMAT				PROTO	:DWORD
MAKEWIN				PROTO	:DWORD, :DWORD

Rows				EQU 25
Colums				EQU 80
XLength				EQU Rows*Colums*4 ;**string length charachter** Incase someone asks because you wont remember it.

.DATA
BTitle				DB	"  ----------     **  Extended ASCII chart displayable characters  **      ----------", 0  
InputB				DWORD 1
;Positioning, directly
UpperRow			DB 218
RightCol			DB 191
LowerRow			DB 192
LeftCol				DB 217
Horizontal			DB 196
Vertical			DB 179

.Data? ; Declare my unitialized Data (Irivine pg568)
ConsoleScreen		CHAR_INFO 2000 DUP (<>) ; Declaring a structured variable, my default field, pg 335
Curs				CONSOLE_CURSOR_INFO <> ;pg 402 the information of the cursor's size and visibility.
Handit1			HANDLE ? ;pg 339, toogles Screen Buffer, could be wrong.
Handit2 			HANDLE ?

WINDESC				SMALL_RECT<>	;pg390 
BufSize				COORD <>
Starter				COORD <> ; Finding X, Y in the DOS field.	

Manyof				DD ?
Buffer				INPUT_RECORD <> ;pg 346, console input functions.


.CODE
speedracer:
WINDESC				PROC
;					INVOKE	SetConsoleTitle, ADDR BTitle ;pg386. Setting the title bar string.
					PUSH	OFFSET BTitle
					CALL	SetConsoleTitle
					CALL	HideTheCursor ;****
;					INVOKE	SetConsoleWindowInfo, Handit1, TRUE, ADDR WINDESC
					PUSH	Handit1, TRUE
					PUSH	OFFSET WINDESC
					CALL	SetConsoleWindowInfo
;					INVOKE	SetConsoleScreenBufferSize, Handit1, DWORD PTR BufSize
					PUSH	Handit1
					PUSH	DWORD PTR BufSize
					CALL	SetConsoleScreenBufferSize
					RET
WINDESC				ENDP

PUTCHAR				PROC
					CALL	SetBufferColor
					INVOKE	MAKEWIN, 1, 3
					INVOKE	MAKEWIN, 4, 25
					RET
PUTCHAR				ENDP

; Fill the buffer with a box of 80 characters
; till the number of line passed as II parameter.
;My 3:45AM Buzz Kill.

MAKEWIN				PROC Row1:DWORD, Row2:DWORD
					MOV		EAX, Row1
					SUB		EAX, 1
					IMUL	EAX, 320 ;pg627 perform a signed integer multiplication.
					MOV		EDX, EAX
					LEA		EAX, ConsoleScreen ;pg631 calculate and load the memory address.  
					ADD		EAX, EDX
					
					MOVZX	EBX, BYTE PTR[UpperRow]
					MOV		BYTE PTR [EAX], BL
					ADD		EAX, 4
					MOV		ECX, 78
					
					MOVZX	EBX, BYTE PTR [Horizontal]
					MOV		BL, Horizontal
Filler1:
					MOV		BYTE PTR[EAX], BL
					ADD		EAX, 4
					DEC		ECX
					JNZ		Filler1
					
					MOVZX	EBX, BYTE PTR [RightCol}
					MOV		BYTE PTR [EAX], BL
					ADD		EAX, 4
					
					MOV		ECX, Row2
					SUB		ECX, ROW1
					DEC 	ECX
					MOVZX	EBX, BYTE PTR [Vertical]
BordFill:
					MOV		BYTE PTR [EAX], BL
					ADD		EAX, 4
					MOV		EDX, 4
					IMUL	EDX, 78
					ADD		EAX, EDX
					MOV		BYTE PTR[EAX], BL
					ADD		EAX, 4
					DEC		ECX
					JNZ		BorderFill
					
					MOVZX	EBX, BYTE PTR [LowerRow]
					MOV		BYTE PTR [EAX], BL
					ADD		EAX, 4
					MOV		ECX, 78
					MOVZX	EBX, BYTE PTR [Horizontal]
					
Filler2:
					MOV		BYTE PTR [EAX], BL
					ADD		EAX, 4
					DEC		ECX
					JNZ		Filler2
					
					MOVZX	EBX, BYTE PTR [LeftCol]
					MOV		BYTE PTR [EAX], BL
					RET
MAKEWIN				ENDP

;Coloring Time XD
SetBufferColor		PROC
					PUSH	EDI
					MOV		EDI, OFFSET ConsoleScreen
					MOV		EAX, 201E2020H
					MOV		ECX, 2000
					REP		STOSD ; repeats what is stored in EAX.
					POP		EDI
					RET
SetBufferColor		ENDP

CURPOS				PROC
;					INVOKE	GetConsoleCursorInfo, Handit1, ADDR Curs
					PUSH	Handit1
					PUSH	OFFSET Curs
					CALL	GetConsoleCursorInfo
					MOV		Curs.bVisible, TRUE
;					INVOKE	SetConsoleCursorInfo, Handle1, ADDR Curs
					PUSH	Handit1
					PUSH	OFFSET Curs
					CALL	SetConsoleCursorInfo
					RET
CURPOS				ENDP

;*****
HideTheCursor		PROC
;					INVOKE	GetConsoleCursorInfo, Handit1, ADDR curs
					PUSH	Handit1
					PUSH	OFFSET curs
					CALL	GetConsoleCursorInfo
					MOV		curs.bVisible, FALSE
;					INVOKE	SetConsoleCursorInfo, Handit1, ADDR curs
					PUSH	Handit1
					PUSH	OFFSET curs
					CALL	SetConsoleCursorInfo
					RET
HidTheCursor		ENDP

InitProc			PROC
					INVOKE	GetStdHandle, STD_INPUT_HANDLE; pg383 return my handle back into EAX, the safekeeper.
					MOV		Handit2, EAX
					INVOKE	GetStdHandle, STD_OUTPUT_HANDLE
					MOV		Handit1, EAX
					
					MOV		windowSize.Left, 0
					MOV		windowSize.Right, 79
					MOV		windowSize.Top, 0
					MOV		windowSize.Bottom, 24
					
					MOV		BufSize.X, 80
					MOV		BufSize.Y, 25
					
					MOV		Starter.X, 0
					MOV		Starter.Y, 0
					RET
InitProc			ENDP

FORMAT				PROC 	szFmtName:DWORD
;					INVOKE	WriteConsoleOutput, Handit1, szFmtName, DWORD PTR BufSize,
;							DWORD PTR Starter, OFFSET WINDESC
					PUSH	OFFSET WINDESC
					PUSH	DWORD PTR Starter
					PUSH	DWORD PTR BufSize
					PUSH	szFmtName
					PUSH	Handit1
					CALL	WriteConsoleOutput
					RET
FORMAT				ENDP

;Returning the key code in buffer.KeyEvent.wVirtualKeyCode WORD size 
AnyKey				PROC
Looper:
;					INVOKE	ReadConsoleInput, Handit2, OFFSET Buffer, 1, OFFSET Manyof
					PUSH	OFFSET Buffer, 1
					PUSH	OFFSET Manyof
					PUSH	Handit2
					CALL	ReadConsoleInput
					
					CMP		Buffer.EventType, KEY_EVENT
					JNZ		Looper
					
					CMP		Buffer.KeyEvent.bKeyDown, 0
					JZ		Looper
					RET
AnyKey				ENDP

EXIT				MACRO
					MOV	AX, 4C00h
					INT 21h
					ENDM

MAIN				PROC
					CALL	InitProc
					CALL	WINDESC
					CALL	WINDESC
					INVOKE	FORMAT, offset ConsoleScreen
					CALL	AnyKey
					CALL	CURPOS
RacerX:
;					INVOKE ExitProcess, 0 ;MS terminates program pg159
					RET
MAIN				ENDP					
END					speedracer